<template>
  <div style="background-color: white">
    <div class="container">
      <FixedTransition
        ref="transition"
        class=""
        :class="{ menuActive }"
        @onHideDone="onContentHidden"
        @onShowDone="onContentShow"
      />

      <div class="center " :class="{top:$route.name!== 'index' || showMenu}">
        <Burger
          class="btn-burger"
          :active="showMenu"
          @click.native="toggleMenu"
        />

        <nuxt-link to="/" aria-label="Homepage">
          <Logo class="logo" :class="{ loading }" />
        </nuxt-link>

        <h1 :class="{ hide: showMenu }">
          <span>{{ pageTitle }}</span>
        </h1>
      </div>
    </div>

    <FixedMenu v-show="showMenu" :active="showMenu" />

    <div class="content">
      <Nuxt />
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      headeritems: null,
      pageTitle: null,
      showMenu: false,
      menuActive: false,
      loading: false,
      transitioning: true,
      contentHidden: false,
      timeout: null,
      waitDelay: 500,
      shows: null,
    }
  },
  watch: {
    $route(newValue, oldValue) {
      this.pageTitle = null
      this.startHeaderTransition()
      setTimeout(() => {
        this.loading = true
        this.showMenu = false
        this.menuActive = false
      }, 100)
    },
  },

  created() {
    this.startHeaderTransition()

    this.$nuxt.$on('transitionStart', (moveUp) => {
      if (!this.transitioning) this.startHeaderTransition(moveUp)
    })

    this.$nuxt.$on('transitionEnd', (moveUp) => {
      if (this.transitioning) this.endHeaderTransition(moveUp)
    })

    this.$nuxt.$on('pageloaded', this.onPageLoaded)
  },

  methods: {
    startHeaderTransition(moveUp) {
      if (this.$refs.transition) {
        if (moveUp) this.menuActive = true

        if (this.$refs.transition) this.$refs.transition.hide()
        this.transitioning = true
      }
    },

    endHeaderTransition() {
      if (this.$refs.transition) this.$refs.transition.show()
      this.transitioning = false
    },

    onPageLoaded(data) {
      this.loading = false
      this.pageTitle = data.title
      this.triggerContentShow()
    },

    onContentHidden() {
      this.contentHidden = true
      this.$nuxt.$emit('onContentHidden')
    },

    onContentShow() {
      this.contentHidden = false
      this.$nuxt.$emit('onContentShow')
    },

    triggerContentShow() {
      const t = this
      if (this.timeout) {
        clearTimeout(this.timeout)
        this.timeout = null
      }
      this.timeout = setTimeout(() => {
        t.endHeaderTransition()
      }, 200)
    },

    toggleMenu() {
      const t = this

      t.showMenu = !t.showMenu

      if (t.showMenu) {
        t.$refs.transition.hide()
        t.menuActive = !t.menuActive
      }

      if (!t.showMenu) {
        t.$refs.transition.show()

        setTimeout(() => {
          t.menuActive = !t.menuActive
        }, this.waitDelay)
      }
    },
  },
}
</script>

<style lang="scss" scoped>
.container {
  @apply text-white   text-center mx-auto max-w-none w-full absolute;
  @screen lg {
    @apply min-h-screen;
  }
}

.content {
  max-width: 100vw;
  min-width: 100vw;
  overflow: hidden;
  @apply -mt-32 pt-32 px-0 w-screen;
  //   padding-top: 100vh;
}

.transition {
  @apply fixed inset-0 z-30;
  pointer-events: none;

  &.menuActive {
    @apply z-40;
  }
}

.center {
  @apply fixed my-4  block z-50 w-full px-10 items-center flex flex-col;
  pointer-events: none;
 
  color: white; // rgb(165, 161, 161);
  mix-blend-mode: difference;
  transition: all 400ms cubic-bezier(0.83, 0, 0.17, 1) 400ms;
  
  top: 0px;
  left: 50%;
  transform: translate(-50%, 0);
  @screen lg{
    top: 50%;
 
  transform: translate(-50%, -50%);
  }
  &.top {
    top: 0px;
    transform: translate(-50%, 0);
    @screen lg{
        top:20px;
    }
  }

  .btn-burger {
    @apply z-50  mb-6;
    mix-blend-mode: difference;
    pointer-events: all;
    &.open {
      //   mix-blend-mode: initial;
    }
    --v-icon-width: 35px;
    --v-icon-height: 20px;
    @screen lg {
      --v-icon-width: 50px;
      --v-icon-height: 30px;
    }
  }
  a {
    pointer-events: all;
  }
  .logo {
    display: block;
    width: 120px;
    @apply mt-0;
    margin-left: 18px;

    @screen lg {
      width: 200px;
      @apply mt-4;
      margin-left: 20px;
    }
  }
  h1 {
    @apply block z-0 mt-6 text-lg font-medium leading-snug uppercase text-center w-full  text-white;
    // max-width: 50vw;
    white-space: pre;
    @screen lg {
      @apply text-2xl mt-6;
    }
    height: 50px;
    display: block;
    span {
      transition: opacity 400ms cubic-bezier(0.83, 0, 0.17, 1);
    }

    &.hide {
      span {
        opacity: 0;
        transition: opacity 400ms cubic-bezier(0.83, 0, 0.17, 1);
      }
    }
  }
}

:deep .anchor-menu {
  @apply z-10 absolute mx-auto grid grid-cols-1 gap-2;

  left: 50%;
  margin-top: -100px;
  @screen lg {
    margin-top: -50px;
  }
  transform: translate(-50%, -100%);
  color: white;
  mix-blend-mode: difference;

  button {
    @apply text-xl uppercase font-medium;
    appearance: none;
    outline: none;

    &:hover {
      @apply underline;
    }
  }
  .icon {
    @apply flex-wrap col-span-2 text-center w-full;
  }
}

// using transition delay so the page gets destroyed only once the transition is hiding the page.
// adjust to <Transition/>'s speed
.page-enter-active,
.page-leave-active {
  transition: opacity 1ms ease 700ms;
}
.page-enter,
.page-leave-active {
  opacity: 0;
}
</style>
